;*************************************************************************
;*
;* Sudoku-OOP (c) Markus Haacke
;*
;*************************************************************************
;*
;* Programname       : Sudoku
;* Filename          : Main.pbi
;* Filetype          : Includefile [Main, Includefile, OOP-Classfile, Datafile]
;* Programming lang. : Purebasic 5.00
;* Need SimpleOOP?   : [X]
;* Autor             : Markus Haacke
;*
;* -----------------------------------------------------------------------
;* BESCHREIBUNG:
;*
;* Lsungsprogramm fr Sudokurtsel
;* Hauptfenster
;*
;* -----------------------------------------------------------------------
;* Historie:
;* 1.00 - rel xx.xx.xx:
;*            Erste Version
;*
;*************************************************************************

;*************************************************************************
;* Procedures
;*************************************************************************
Procedure   Prc_Main_InitGadgets()
	; +-----------------------------------------------------------------
	; |Description  : Initialisiert Gadgets
	; |Arguments    : -
	; |Results      : -
	; +-----------------------------------------------------------------
	
EndProcedure
Procedure   Prc_Main_FreeGadgets()
	; +-----------------------------------------------------------------
	; |Description  : Gadgets freigeben
	; |Arguments    : -
	; |Results      : -
	; +-----------------------------------------------------------------
	
EndProcedure
;-
Procedure   Prc_Main_InitObjects()
	; +-----------------------------------------------------------------
	; |Description  : Initialisiert OOP-Objekte
	; |Arguments    : -
	; |Results      : -
	; +-----------------------------------------------------------------
	
	*MySudoku = NewObject.Sudoku()
	
EndProcedure
Procedure   Prc_Main_FreeObjects()
	; +-----------------------------------------------------------------
	; |Description  : OOP-Objekte freigeben
	; |Arguments    : -
	; |Results      : -
	; +-----------------------------------------------------------------
	
	*MySudoku = FreeObject
	
EndProcedure
;-
Procedure   Prc_Main_RegisterEvents()
  ; +-----------------------------------------------------------------
  ; |Description  : Ordnet den Gadgets die Eventprozeduren zu
  ; |Arguments    : -
  ; |Results      : #False, wenn Fehler aufgetreten sind, sonst #True
  ; +-----------------------------------------------------------------

	evh_SetGadgetEvent(Window_Main, Window_Main_Button_Quit, #PB_EventType_LeftClick, @ButtonQuit_LeftClick())

EndProcedure
;-
Procedure.i Prc_Main_OpenWindow()
  ; +-----------------------------------------------------------------
  ; |Description  : ffnet das Programmfenster
  ; |Arguments    : -
  ; |Results      : #False, wenn Fehler aufgetreten sind, sonst #True
  ; |Remarks      : -
  ; +-----------------------------------------------------------------

	OpenWindow_Window_Main()
	
	If IsWindow(Window_Main)
		Prc_Main_InitGadgets()
		Prc_Main_InitObjects()
		Prc_Main_RegisterEvents()
		ProcedureReturn #True
  Else	
		ProcedureReturn #False
  EndIf

EndProcedure
Procedure   Prc_Main_CloseWindow()
  ; +-----------------------------------------------------------------
  ; |Description  : Schliet das Programmfenster
  ; |Arguments    : -
  ; |Results      : -
  ; +-----------------------------------------------------------------
  
  If IsWindow(Window_Main)
		Prc_Main_FreeObjects()
		Prc_Main_FreeGadgets()
  	CloseWindow(Window_Main)
  EndIf

EndProcedure
;-

;*************************************************************************
;* Eventprocedures
;*************************************************************************
Procedure   ButtonQuit_LeftClick(*stEventArgs.evh_EventArgsstruct)
  ; +-----------------------------------------------------------------
  ; |Description  : Bearbeitung des #PB_EventType_LeftClick Events
  ; |Arguments    : Standard Eventhandlerparameter (siehe Include "Eventhandler.pb")
  ; |Results      : -
  ; +-----------------------------------------------------------------
  
	SendMessage_(WindowID(Window_Main), #PB_Event_CloseWindow, 0, 0)
	
EndProcedure
;-

;*************************************************************************
;* Mainprocedure (Eventloop)
;*************************************************************************
Procedure   Prc_Main_Main()
  ; +-----------------------------------------------------------------
  ; |Description  : Einsprungprozedur, enthlt den Messageloop des Programms
  ; |Arguments    : -
  ; |Results      : -
  ; +-----------------------------------------------------------------

	;*************************************************************************
	;* Initializing code
	;*************************************************************************
	
	; Fenster ffnen und GadgetEvents setzen
	ErrorCheck(Prc_Main_OpenWindow(), "Open Window")
	
	;*************************************************************************
	;* Eventloop
	;*************************************************************************
	
	While NoError And evh_ProcessEvents(25, Window_Main)										;, @OwnEventproc(), @stOwnEvents)
	Wend

	;*************************************************************************
	;* Exit code
	;*************************************************************************
	
	If Not NoError
		MessageRequester("Fehler!", "Es ist ein Fehler aufgetreten! " + #CR$ + "Fehlermeldung: " + LastError + #CR$ + #CR$ + "Das Programm wird beendet.", #MB_ICONERROR)
	EndIf

	; Fenster schlieen
	Prc_Main_CloseWindow()

EndProcedure
