;*************************************************************************
;*
;* Sudoku-OOP (c) Markus Haacke
;*
;*************************************************************************
;*
;* Programname       : Sudoku
;* Filename          : Sudoku.pb
;* Filetype          : Main [Main, Includefile, OOP-Classfile, Datafile]
;* Programming lang. : Purebasic 5.00
;* Need SimpleOOP?   : [X]
;* Compile as        : Windows Exe
;* Version           : 1.00
;* Date              : 21.12.2012
;* Autor             : Markus Haacke
;* -----------------------------------------------------------------------
;* BESCHREIBUNG:
;*
;* Lsungsprogramm fr Sudokurtsel
;*
;* -----------------------------------------------------------------------
;* Historie:
;* 1.00 - rel xx.xx.xx:
;*            Erste Version
;*
;*************************************************************************

;*************************************************************************
;* Compiler directives
;*************************************************************************

EnableExplicit

;*************************************************************************
;* Macros
;*************************************************************************

; Macro zum Aufruf von Prozeduren die einen Fehlercode zurckgeben
; Rckgabe #False = Fehler aufgetreten, #True = alles Okay
Macro ErrorCheck(ProcdureCall, ErrorDescription)
	If NoError
		LastError = ErrorDescription
		NoError * ProcdureCall
	EndIf
EndMacro

;*************************************************************************
;* Global Constants
;*************************************************************************

#Version = "Version 1.00"

;*************************************************************************
;* Global Structures
;*************************************************************************

;*************************************************************************
;* Global Variables
;*************************************************************************

; Varaiablen fr die Fehlerbehandlung
Global NoError.i = #True
Global LastError.s = ""

;*************************************************************************
;* Global Arrays, Linked lists, Maps
;*************************************************************************

;*************************************************************************
;* OOP Classes & Objektvariables (if SimpleOOP is used)
;*************************************************************************

IncludeFile "OOP_Sudokuclass.pbi"
Global *MySudoku.Sudoku

;*************************************************************************
;* Includefiles
;*************************************************************************

IncludeFile "GUI.pbi"																											; %IGNOREFILE
IncludeFile "Eventhandler.pbi"																						; %IGNOREFILE
IncludeFile "Declarations.pbi"																						; %DECLAREFILE
IncludeFile "Main.pbi"


;*************************************************************************
;* Calling Mainprocedure
;*************************************************************************

Prc_Main_Main()

End

;*************************************************************************
;* Data Section
;*************************************************************************

; DataSection
; 	Image:
;     IncludeBinary "Daten\Icons\Image.bmp"
; EndDataSection
